//=========ARDUINO JSON=========================================
#include <ArduinoJson.h>
//===== LIBRARIES ============================================
#include <WiFi.h>
#include <HTTPClient.h>
//===========     WIFI MANAGER==========
#include <WiFiManager.h>
//===============SPI LIBRARY===================================
#include <SPI.h>
// ===========RFID MFRC522 LIBRARY=============================
#include <MFRC522.h>
//=============== MLX90614 LIBRARY ============================
#include <Adafruit_MLX90614.h>
Adafruit_MLX90614 mlx = Adafruit_MLX90614();
double temp_obj;
double calibration = 2.36;
String temp;
double total;


//====================OLED DISPLAY==========================
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define SCREEN_WIDTH 128    // OLED display width, in pixels
#define SCREEN_HEIGHT 64    // OLED display height, in pixels
#define OLED_RESET -1       // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

//===========BUZZER=========================================
const int buzzer = 25;
//=============SERIALIZE JSON DOC============================
StaticJsonDocument<192> doc;
//=========HOLD CARD NUMBER===================================
String card; // String variable to hold the card number in hex
// ====RFID COMMUNICATION PINS=================================
#define SS_PIN 5
#define RST_PIN 14
#define relay 12
//======WIFI CREDENTILAS =====================================
//const char* ssid = "Xperia";
//const char* password = "505050jr@@";
//======Parameters============================================
const int ipaddress[4] = {103, 97, 67, 25};
//======VARIABLES FOR MFRC522==================================
byte nuidPICC[4] = {0, 0, 0, 0};
MFRC522::MIFARE_Key key;
MFRC522 rfid = MFRC522(SS_PIN, RST_PIN);
void setup() {
   //Init Serial USB
   pinMode(relay,OUTPUT);
   digitalWrite(relay,HIGH);
  Serial.begin(115200);
  //==WIFI MANAGER ==========================================
   WiFiManager wifiManager;
  //====INIT OLED=============================================
    display.begin(SSD1306_SWITCHCAPVCC, 0x3C); //initialize with the I2C addr 0x3C (128x64)
  //==========================================================
  pinMode(buzzer,OUTPUT);
  //======================BOOTING=====================
  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("BOOTING...");
  display.display();
  delay(2500);
//===============SET AP OR AUTO RECONNECT============================
//exit after config instead of connecting

  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("CONNECTING");
  display.setCursor(0,30);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("TO WIFI...");
  display.display();
  delay(3000);
  wifiManager.setBreakAfterConfig(true);

bool success = wifiManager.autoConnect("CONNECT-Me Sir", "password");
if(!success) {
        Serial.println("Failed to connect");
        setwifi_first();
        delay(3000);
        ESP.restart();
       delay(5000);
    } 
    else {
       pconnected();
    }

 


  //=========RFID INIT=========================================
  Serial.println(F("Initialize System"));
  //init rfid D8,D5,D6,D7
  SPI.begin();
  rfid.PCD_Init();
  Serial.print(F("Reader :"));
  rfid.PCD_DumpVersionToSerial();
  
  //==========MLX90614 INIT =====================================
  while (!Serial);
  if (!mlx.begin()) {
    Serial.println("Error connecting to MLX sensor. Check wiring.");
  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Check Sensor wiring");
  display.display();
    while (1);
  };
  //=============================================================
  Serial.println(F("Scan for Card and print UID:"));
  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("PLACE FINGER  ");
  display.setCursor(0,30);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("AND  YOUR CARD");
  display.display();
  delay(2500);
}
void loop() {
  temp_obj = mlx.readObjectTempC();
  readRFID();
  
}
void readRFID(void ) { /* function readRFID */
  ////Read RFID card
  for (byte i = 0; i < 6; i++) {
      key.keyByte[i] = 0xFF;
  }
  // Look for new 1 cards
  if ( ! rfid.PICC_IsNewCardPresent())
      return;
  // Verify if the NUID has been readed
  if (  !rfid.PICC_ReadCardSerial())
      return;
  // Store NUID into nuidPICC array
  for (byte i = 0; i < 4; i++) {
      nuidPICC[i] = rfid.uid.uidByte[i];
  }

  // Build the card number in hex format
    card = "";
    for (byte i = 0; i < rfid.uid.size; i++) {
      if (rfid.uid.uidByte[i] < 0x10) {
        card += "0";
      }
      card += String(rfid.uid.uidByte[i], HEX);
      card += "";
      
    }
    //========buzzer========
    digitalWrite(buzzer,HIGH);
    delay(1000);
    digitalWrite(buzzer,LOW);
    
    //======================
    card.toUpperCase(); // Convert to uppercase letters
    Serial.print(F("Card Number: "));
    Serial.println(card);

     //display user info on OLED 
     total= temp_obj + calibration;
    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.println("Body Temp: " + String(total) + "C");
    display.setCursor(0, 30);
    display.println("Tag ID: " + card);
    display.display();
    delay(3000);
    
  //SENDING TO SERVER 
    send_to_server();

  // Halt PICC
  rfid.PICC_HaltA();
  // Stop encryption on PCD
  rfid.PCD_StopCrypto1();
}

//============PRINTING NUMBER IN HEX==================
void printHex(byte *buffer, byte bufferSize) {
  for (byte i = 0; i < bufferSize; i++) {
      Serial.print(buffer[i] < 0x10 ? "0" : "");
      Serial.print(buffer[i], HEX);
    
  }
}
// ============FUNCTION TO PRINT NUMBER IN DEC========================
void printDec(byte *buffer, byte bufferSize) {
  for (byte i = 0; i < bufferSize; i++) {
      Serial.print(buffer[i] < 0x10 ? "0" : "");
      Serial.print(buffer[i], HEX);
  }
}


void readTemp(){
  Serial.print("Object temperature = "); 
  Serial.print(temp_obj); 
  Serial.println("°C");
  delay(100);
  }
void send_to_server(){

  //sending to server 
  display.clearDisplay();
  display.setCursor(0,15);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("CONTACTING SERVER");
  display.setCursor(0,30);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("PLEASE WAIT...");
  display.display();
  delay(2000);
       if(WiFi.status() == WL_CONNECTED){
               //send the web request now and check if the result is processed
                HTTPClient http;
                total= temp_obj + calibration;
                 temp=String(total);
                // configure traged server and url
                //http.begin("https://192.168.1.12/test.html", "7a 9c f4 db 40 d3 62 5a 6e 21 bc 5c cc 66 c8 3e a1 45 59 38"); //HTTPS
                http.begin("http://192.168.43.88:4005/card?rfid="+card+"&temp="+temp); //HTTP
                Serial.print("[HTTP] GET...\n");
                // start connection and send HTTP head
                int httpCode = http.GET();
                // httpCode will be negative on error
                if(httpCode > 0) {
                    // HTTP header has been send and Server response header has been handled
                    //Serial.printf("[HTTP] GET... code: %d\n", httpCode);
        
                    // file found at server
                    if(httpCode == HTTP_CODE_OK) {
                      String payload = http.getString();
                      Serial.println(payload);
 DeserializationError error = deserializeJson(doc, payload);

if (error) {
  Serial.print(F("deserializeJson() failed: "));
  Serial.println(error.f_str());
  return;
}

const char* firstname = doc["firstname"]; // "RUKUNDO"
const char* lastname = doc["lastname"]; // "Jean claude "
String B_status = doc["status"]; // "Normal"
float temp = doc["temp"]; // 26.95
Serial.println(firstname);
Serial.println(lastname);
Serial.println(B_status);
Serial.println(temp);

if(B_status == "Normal"){

  display.clearDisplay();
  display.setCursor(0,0);
  display.setTextSize(1);
  display.print("FIRSTNAME:");
  display.print(firstname);
  //display.print((char)247);
  display.setCursor(0,15);
  display.setTextSize(1);
  display.print("LASTNAME:");
  display.print(lastname);
  display.setCursor(0,30);
  display.setTextSize(1);
  display.print("STATUS:");
  display.print(B_status);
  //display.print((char)247);
  display.setCursor(0,45);
  display.setTextSize(1);
  display.print("Body Temp: ");
  display.print(temp_obj + calibration);
  display.print((char)247);
  display.print("C");
  display.setCursor(0,55);
  display.setTextSize(1);
  display.print("PASS: ");
  display.print("ALLOWED");
  //display.print((char)247);
  display.display();
  //==== OPEN DOOR FOR 6 SECS========
  digitalWrite(relay,LOW);
  //=====CLOSE DOOR =================
  delay(1500);
  digitalWrite(relay,HIGH);
  welcome();
                       }
                        else if(B_status == "Abnormal"){
   display.clearDisplay();
  display.setCursor(0,0);
  display.setTextSize(1);
  display.print("FIRSTNAME:");
  display.print(firstname);
  //display.print((char)247);
  display.setCursor(0,15);
  display.setTextSize(1);
  display.print("LASTNAME:");
  display.print(lastname);
  display.setCursor(0,30);
  display.setTextSize(1);
  display.print("STATUS:");
  display.print(B_status);
  //display.print((char)247);
  display.setCursor(0,45);
  display.setTextSize(1);
  display.print("Body Temp: ");
  display.print(temp_obj + calibration);
  display.print((char)247);
  display.print("C");
  display.setCursor(0,55);
  display.setTextSize(1);
  display.print("PASS: ");
  display.print("DENIED");
  //display.print((char)247);
  display.display();
  delay(5000);
    welcome();
                          }
                          else if (B_status == "Unregistered"){
  display.clearDisplay();
  display.setCursor(0,0);
  display.setTextSize(1);
  display.print("STATUS: ");
  display.print(B_status);
   display.setCursor(0,20);
  display.setTextSize(1);
  display.print("Body Temp: ");
  display.print(temp);
  //display.print((char)247);
  display.setCursor(0,40);
  display.setTextSize(1);
  display.print("PASS: ");
  display.print("DENIED");
  //display.print((char)247);
  display.display();
  delay(5000);
  welcome();
  
  }                         

 else if (B_status == "nobody"){
                             
  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("NO BODY");
  display.setCursor(0,40);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("DETECTED");
  display.display();
  delay(5000);
  welcome();             

                  }
    else if (B_status == "nocard"){
  display.clearDisplay();
  display.setCursor(10,15);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("NO BODY");
  display.setCursor(10,40);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("DETECTED");
  display.display();
  delay(5000);
  welcome();         
    }
                     
                      }  
            } else {
  Serial.printf("[HTTP] GET CALL FAILED %s\n", http.errorToString(httpCode).c_str());

  display.clearDisplay();
  display.setCursor(25,15);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Error Code:500");
  display.setCursor(25,35);
  display.setTextSize(1);
  display.print("SERVER IS DOWN");
  display.display();
   for (int i =0; i<3; i++){
                    digitalWrite(buzzer,HIGH);
                    delay(100);
                    digitalWrite(buzzer,LOW);
                    delay(100);
                    } 
               delay(3000);
               welcome();
               
                
                }
             } else{
  Serial.println("No WiFi Avaialable Now!!!!!");
  display.clearDisplay();
  display.setCursor(25,15);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("NO WIFI ");
  display.setCursor(25,35);
  display.setTextSize(1);
  display.print("Available");
  display.display();
    for (int i =0; i<6; i++){
                    digitalWrite(buzzer,HIGH);
                    delay(100);
                    digitalWrite(buzzer,LOW);
                    delay(100);
                    }   
                delay(3000);   
               welcome();
                           
                    }               
                    }
 
void setwifi_first(){
  display.clearDisplay();
  display.setCursor(10,0);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("SET WIFI FIRST");
  display.display();
 
  }
  void pconnected(){
      Serial.println("");
 //====================WIFI CONNECTED ====================
  Serial.println(F("WiFi connected"));
  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("WIFI");
  display.setCursor(0,30);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("CONNECTED");
  display.display();
  delay(3000);
 //=========================================================
  Serial.println(WiFi.localIP());
    }

  //OLWAYS ON MESSAGE (welcome();)
void welcome(){
  display.clearDisplay();
  display.setCursor(0,0);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Place Finger ");
  display.setCursor(0,30);  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("AND  YOUR CARD");
  display.display();
  }

    


  
  
